// leetcode 05. Longest Palindromic Substring
// https://www.youtube.com/watch?v=g3R-pjUNa3k

struct Solution;

impl Solution {

    pub fn longest_palindrome(s: String) -> String {
        let l = s.len();
        if l == 0 { return "".to_string(); }


        let sv = s.chars().collect::<Vec<char>>();
        let mut start = 0;
        let mut end = 0;
        for i in 0..sv.len() {
            let mut left = i;
            let mut right = left;
            // 回文常用手段
            while right+1 < l && sv[left] == sv[right+1] {
                right +=1;
            }

            while left > 0 && right+1 < l && sv[left-1] == sv[right+1] {
                left -=1;
                right += 1
            }

            if (right - left) > (end - start) {
                end = right;
                start = left;
            }


        }


        sv[start..=end].iter().collect()

    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_longest_palindrome() {
        let s =  vec!["babad"];
        let res: Vec<String> = s.iter().map(|&s| {
            Solution::longest_palindrome(s.into())

        }).collect();

        assert_eq!(res, ["bab"]);


    }
}