struct Solution;

impl Solution {
    pub fn sort_colors(nums: &mut Vec<i32>) {
        let l = nums.len();
        if l == 0 { return; }
        let mut start = 0;
        let mut end = l - 1;
        let mut i = 0;
        while i <= end {
            if nums[i] < 1 {
                nums[start] = 0;
                start += 1;
                i += 1;
            } else if nums[i] > 1 {
                nums[i] = nums[end];
                nums[end] = 2;
                if end == 0 { return; }
                end -= 1;

            } else {
                i += 1;
            }
        }
        for j in start..=end {
            nums[j] = 1;
        }

    }
}

#[cfg(test)]
mod tests {

    use super::*;

    #[test]
    fn test_sort_colors1() {
        let mut nums = vec![2,0,2,1,1,0];
        Solution::sort_colors(&mut nums);

        assert_eq!(nums, vec![0,0,1,1,2,2]);

    }

    #[test]
    fn test_sort_colors2() {
        let mut nums = vec![0,0];
        Solution::sort_colors(&mut nums);

        assert_eq!(nums, vec![0,0]);

    }
}