
struct Solution;


impl Solution {
    pub fn subsets_with_dup(nums: Vec<i32>) -> Vec<Vec<i32>> {
        let mut res = vec![];
        let mut nums = nums;
        nums.sort();
        println!("nums: {:?}", nums);
        let n = nums.len();
        let mut cur = vec![];
        Solution::helper(&nums, 0, n, &mut cur, &mut res);
        res

    }

    fn helper(nums: &Vec<i32>, idx: usize, n: usize, cur: &mut Vec<i32>, res: &mut Vec<Vec<i32>>) {
        if idx == n {
            res.push(cur.clone());
            return
        }
        let i = idx;
        let mut count = 1;
        let mut j = i + 1;
        while j < n && nums[j] == nums[i] {
            count += 1;
            j += 1;
        }

        for k in 0..=count {
            for _ in 0..k as usize {
                cur.push(nums[i]);
            }
            Solution::helper(nums, i + count as usize, n, cur, res );
            for _ in 0..k as usize {
                cur.pop();
            }
        }

    }
}


#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_subsets_with_dup() {
        let nums = vec![1,2,2];
        let res = Solution::subsets_with_dup(nums);
        assert_eq!(res, vec![vec![],vec![2],vec![2,2],vec![1],vec![1,2],vec![1,2,2]])
    }

    #[test]
    fn test_subsets_with_dup2() {
        let nums = vec![1,1,2,2];
        let res = Solution::subsets_with_dup(nums);
        assert_eq!(res, vec![vec![],vec![2],vec![2,2],vec![1],vec![1,2],vec![1,2,2],vec![1, 1], vec![1, 1, 2], vec![1, 1, 2, 2]])
    }
}