struct Solution;

impl Solution {
    pub fn length_of_last_word(s: String) -> i32 {
        let mut begin = false;
        let mut count = 0;
        let mut ans = 0;
        for c in s.chars() {
            if !begin && c == ' ' {
                continue;
            } else if !begin && c != ' ' {
                begin = true;
                count += 1;
            } else if begin && c == ' ' {
                begin = false;
                ans = count;
                count = 0;
            } else {
                count += 1;
            }
        }

        if count != 0 {
            ans = count;
        }

        ans
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case1() {
        let s = "luffy is still joyboy";
        let res = Solution::length_of_last_word(s.to_string());
        assert_eq!(res, 6);
    }

    #[test]
    fn test_case2() {
        let s = "   fly me   to   the moon  ";
        let res = Solution::length_of_last_word(s.to_string());
        assert_eq!(res, 4);
    }
}
