// Leetcode 6. Zigzag Conversion

struct Solution;

impl Solution {
    pub fn convert(s: String, num_rows: i32) -> String {
        if num_rows == 1 {
            return s;
        }
        let mut result = vec![String::new(); num_rows as usize];
        let mut row = 0 as i32;
        let mut direction = 1 as i32;
        for c in s.chars() {
            println!("{} {} {}", c, row, direction);

            result[row as usize ].push(c);
            row += direction ;
            if row == 0 || row == num_rows - 1 {
                direction = -direction;
            }
        }
        result.concat()

    }
    pub fn convert2(s: String, num_rows: i32) -> String {
        if num_rows == 1 {
            return s;
        }

        let v = s.chars().into_iter().collect::<Vec<_>>();
        let mut res: Vec<char> = vec![];
        let l = v.len();
        for i in 0..num_rows {
            println!("{}", i);
            let  j = i as usize;
            let mut count: usize = 0;
            let total = (2*num_rows -2) as usize;
            let mut step0 =((num_rows - i - 1) * 2 ) as usize;
            if i == num_rows -1 {
                step0 = total;
            }
            let step1 = total - (step0 % total) ;

            // println!("step0: {}, step1 {}", step0, step1);
            let mut cur_j = j;
            while cur_j < l {
                println!("cur_j: {}", cur_j);

                res.push(v[cur_j]);
                count += 1;

                if count % 2 == 1 {
                    cur_j += step0;

                } else {
                     cur_j +=  step1;
                }

                // std::thread::sleep(std::time::Duration::from_secs(4));
            }

        }

        res.into_iter().collect()

    }
}

#[cfg(test)]
mod tests {

    use super::Solution;
    #[test]
    fn test_convert() {
        let a =  vec!["PAYPALISHIRING", "PAYPALISHIRING"];
        let b =  vec![3, 4];
        let res: Vec<String> = a.iter().zip(b.iter()).map( |(&a, &b)| {
            Solution::convert(a.into(),b)

        }).collect();

        assert_eq!(res, ["PAHNAPLSIIGYIR", "PINALSIGYAHRPI"]);

    }
    #[test]
    fn test_convert2() {
        let a =  vec!["PAYPALISHIRING", "PAYPALISHIRING"];
        let b =  vec![3, 4];
        let res: Vec<String> = a.iter().zip(b.iter()).map( |(&a, &b)| {
            Solution::convert2(a.into(),b)

        }).collect();

        assert_eq!(res, ["PAHNAPLSIIGYIR", "PINALSIGYAHRPI"]);

    }

}