struct Solution;

impl Solution {
    pub fn plus_one(digits: Vec<i32>) -> Vec<i32> {
        let mut res = vec![];
        let mut flag = false;
        for &n in digits.iter().rev() {
            if flag {
                res.push(n);
                continue;
            }
            if n == 9 {
                res.push(0);
            } else {
                res.push(n + 1);
                flag = true;
            }
        }
        if !flag {
            res.push(1);
        }

        res.reverse();
        res
    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_case_1() {
        let digits = vec![1, 0];
        let res = Solution::plus_one(digits);
        assert_eq!(res, vec![1, 1]);
    }

    #[test]
    fn test_case_2() {
        let digits = vec![9];
        let res = Solution::plus_one(digits);
        assert_eq!(res, vec![1, 0]);
    }
}
