struct Solution;
impl Solution {
    pub fn search_matrix(matrix: Vec<Vec<i32>>, target: i32) -> bool {
        let rows = matrix.len();
        if rows == 0 { return false; }
        let cols = matrix[0].len();
        if cols == 0 { return false; }
        let mut l = 0;
        let mut r  = rows * cols - 1;
        while l <= r {
            let mid = (l + r) / 2;
            let i = mid / cols;
            let j = mid % cols;
            if matrix[i][j] == target {
                return true;
            }
            if matrix[i][j] < target {
                l = mid + 1;
            } else {
                if mid == 0 {
                    return false;
                }
                r = mid - 1;
            }
        }



        false

    }
}

#[cfg(test)]
mod tests {
    use super::*;

    #[test]
    fn test_search_matrix1() {
        let matrix = vec![vec![1,3,5,7],vec![10,11,16,20],vec![23,30,34,60]];
        let target = 3;
        let res = Solution::search_matrix(matrix, target);
        assert_eq!(res, true);
    }


}