struct Solution;

impl Solution {
    pub fn permute(nums: Vec<i32>) -> Vec<Vec<i32>> {
        let mut nums = nums;
        let mut res = Vec::new();
        res.push(nums.clone());
        Self::helper(&mut nums, 0, &mut res);

        res
    }

    fn helper(nums: &mut Vec<i32>, i: usize, res: &mut Vec<Vec<i32>>) {
        for k in (i)..nums.len() {
            if k == i {
                Solution::helper(nums, i + 1, res);
            } else {
                nums.swap(i, k);
                res.push(nums.clone());
                Solution::helper(nums, i + 1, res);

                nums.swap(i, k);
            }
        }
    }
}

#[cfg(test)]
mod tests {
    use std::vec;

    use super::*;

    #[test]
    fn test_case1() {
        let nums = vec![1, 2, 3];
        let expect = vec![
            vec![1, 2, 3],
            vec![1, 3, 2],
            vec![2, 1, 3],
            vec![2, 3, 1],
            vec![3, 2, 1],
            vec![3, 1, 2],
        ];

        let res = Solution::permute(nums);
        assert_eq!(res, expect);
    }
}
